#!/bin/sh

if ! ./compatible.sh ; then
	exit 1
fi

busybox echo -n '[<0x0,0x410000><0x410000,0x614000><0x614000,0x914000><0x914000,0x1314000><0x1314000,0x2014000><0x2014000,0x2d14000><0x2d14000,0x3e14000>]' > upd_stat

if ./is_nor /dev/mtd ; then
	if ! ./norwrite2 -k 0x0 -l 0x0 -s 0x0 -p /dev/mtd images/mtd1 ; then
		echo 'burn /dev/mtd1 failed'; exit 1
	fi
elif ./is_nand /dev/mtd ; then
	if ! ./nandwrite2 -k 0x0 -l 0x0 -s 0x0 -p -o -u 0x410000 /dev/mtd images/mtd1; then
		echo 'burn /dev/mtd1 failed'; exit 1
	fi
else
	echo 'Cant identify flash type' ; exit 1
fi
if ./is_nor /dev/mtd ; then
	if ! ./norwrite2 -k 0x410000 -l 0x0 -s 0x410000 -p /dev/mtd images/mtd2 ; then
		echo 'burn /dev/mtd2 failed'; exit 1
	fi
elif ./is_nand /dev/mtd ; then
	if ! ./nandwrite2 -k 0x410000 -l 0x0 -s 0x410000 -p -o -u 0x614000 /dev/mtd images/mtd2; then
		echo 'burn /dev/mtd2 failed'; exit 1
	fi
else
	echo 'Cant identify flash type' ; exit 1
fi
if ./is_nor /dev/mtd ; then
	if ! ./norwrite2 -k 0x614000 -l 0x0 -s 0x614000 -p -u 0x914000 /dev/mtd images/mtd3 ; then
		echo 'burn /dev/mtd3 failed'; exit 1
	fi
elif ./is_nand /dev/mtd ; then
	if ! ./nandwrite2 -k 0x614000 -l 0x0 -s 0x614000 -p -o -u 0x914000 /dev/mtd images/mtd3; then
		echo 'burn /dev/mtd3 failed'; exit 1
	fi
else
	echo 'Cant identify flash type' ; exit 1
fi
if ./is_nor /dev/mtd ; then
	if ! ./norwrite2 -k 0x914000 -l 0x0 -s 0x914000 -p -u 0x1314000 /dev/mtd images/mtd4 ; then
		echo 'burn /dev/mtd4 failed'; exit 1
	fi
elif ./is_nand /dev/mtd ; then
	if ! ./nandwrite2 -k 0x914000 -l 0x0 -s 0x914000 -p -o -u 0x1314000 /dev/mtd images/mtd4; then
		echo 'burn /dev/mtd4 failed'; exit 1
	fi
else
	echo 'Cant identify flash type' ; exit 1
fi
if ./is_nor /dev/mtd ; then
	if ! ./norwrite2 -k 0x1314000 -l 0x0 -s 0x1314000 -p /dev/mtd images/mtd5 ; then
		echo 'burn /dev/mtd5 failed'; exit 1
	fi
elif ./is_nand /dev/mtd ; then
	if ! ./nandwrite2 -k 0x1314000 -l 0x0 -s 0x1314000 -p -o -u 0x2014000 /dev/mtd images/mtd5; then
		echo 'burn /dev/mtd5 failed'; exit 1
	fi
else
	echo 'Cant identify flash type' ; exit 1
fi
if ./is_nor /dev/mtd ; then
	if ! ./norwrite2 -k 0x2014000 -l 0x0 -s 0x2014000 -p /dev/mtd images/mtd6 ; then
		echo 'burn /dev/mtd6 failed'; exit 1
	fi
elif ./is_nand /dev/mtd ; then
	if ! ./nandwrite2 -k 0x2014000 -l 0x0 -s 0x2014000 -p -o -u 0x2d14000 /dev/mtd images/mtd6; then
		echo 'burn /dev/mtd6 failed'; exit 1
	fi
else
	echo 'Cant identify flash type' ; exit 1
fi
if ./is_nor /dev/mtd ; then
	if ! ./norwrite2 -k 0x2d14000 -l 0x0 -s 0x2d14000 -p /dev/mtd images/mtd7 ; then
		echo 'burn /dev/mtd7 failed'; exit 1
	fi
elif ./is_nand /dev/mtd ; then
	if ! ./nandwrite2 -k 0x2d14000 -l 0x0 -s 0x2d14000 -p -o -u 0x3e14000 /dev/mtd images/mtd7; then
		echo 'burn /dev/mtd7 failed'; exit 1
	fi
else
	echo 'Cant identify flash type' ; exit 1
fi
busybox echo -n [END] > upd_stat

busybox sync
